// GLOBALS
uint8_t step_lcd = 0;
uint8_t cnt_lcd = 0;

// Tastusvariabeln
uint8_t keybrd = 0x00;						// Tastaturpuffer

// Interrupt-Status-Variabeln
uint8_t _TMR0 = 0;
uint8_t _TMR1 = 0;
uint8_t _TMR2 = 0;


// INTERRUPTS

// ----------------------------------------------------------
// Interrupt fr Weckalarm
ISR(INT_ALARM){

	flash_time = 1;					// Alarmanzeige auslsen
	led_color = alarm_color;		// Alarmfarbe zuweisen

}
// ----------------------------------------------------------


// ----------------------------------------------------------
// Interrupt fr Tastatur
ISR(INT_KEYBRD){

	keybrd = twi_read( IO_ADDR, 0x00 );

}
// ----------------------------------------------------------


// ----------------------------------------------------------
// Interrupt fr LED-Farben-Timer TIMER0
ISR(INT_TMR0){

	_TMR0 = 1;	
	
}

void _tmr0(){

	static uint8_t pwm_step = 0;
	static uint8_t step = 0;;

	if( pwm_step >= PWM_COUNT_LED ){
		
		if( led_color.R >= step ) PORTD = PORTD | (1 << LED_R);
		else PORTD &= ~(1 << LED_R);

		if( led_color.G >= step ) PORTD = PORTD | (1 << LED_G);
		else PORTD &= ~(1 << LED_G);

		if( led_color.B >= step ) PORTD = PORTD | (1 << LED_B);
		else PORTD &= ~(1 << LED_B);

		if( step >= 255 ) step = 0;
		else step++;

		pwm_step = 0;
		

	}
	else pwm_step++;

	_TMR0 = 0;

	return;

}
// ----------------------------------------------------------


// ----------------------------------------------------------
// Interrupt fr Helligkeits-Timer TIMER2
ISR(INT_TMR2){

	_TMR2 = 1;

}

void _tmr2(){

	// Interrupt fr berlauf TIMER2
	static uint8_t pwm_step = 0;
	static uint8_t step = 0;

	if( pwm_step >= PWM_COUNT_BRIGHT ){
		
		if( led_color.brightness >= step ) PORTC &= ~(1 << LED_BRIGHT);
		else PORTC = PORTC | (1 << LED_BRIGHT);

		pwm_step = 0;

		if( step >= 255 ) step = 0;
		else step++;
		

	}
	else pwm_step++;

	_TMR2 = 0;

	return;

}
// ----------------------------------------------------------


// ----------------------------------------------------------
// Interrupt fr Anzeigezeit-Timer TIMER1
ISR(INT_TMR1){

	_TMR1 = 1;	

}

void _tmr1(){

	// Interrupt fr berlauf TIMER1
	static uint8_t pwm_step = 0;


	if( pwm_step >= PWM_COUNT_LCD){
		
		if( step_lcd >= 30) step_lcd = 0;
		else step_lcd++;
		
		if( step_lcd % 3 == 0 && step_lcd != 0 ){

			if( cnt_lcd == 0 ) cnt_lcd = 1;
			else cnt_lcd = 0;

		}		

		pwm_step = 0;


	}
	else pwm_step++;

	_TMR1 =0;

	return;

}
// ----------------------------------------------------------
