// INITIIERUNG DER MENSTRUKTUR
#include "menue_functions.h"

struct menueP{

	char name[17];
	
	void (*func)(uint8_t);	
	uint8_t fdata;

	struct menueP *prev;
	struct menueP *next;
	struct menueP *parent;
	struct menueP *child;

};


struct menueP *start;


//--------------------------------------------------------------

struct menueP* new_menueP(char *name){

	// Erstellt einen neuen Menpunkt

	struct menueP* tmp;
	tmp = (struct menueP *)malloc( sizeof(struct menueP) );

	strcpy(tmp -> name , name);
	tmp -> func = NULL;
	tmp -> parent = NULL;
	tmp -> child = NULL;
	tmp -> fdata = 0;

	return tmp;

}

void init_menue(){

	// Erstellt die Menstruktur
	struct menueP *m1, *m2, *m3, *m4, *m11, *m12, *m21, *m22, *m23, *m31, *m32, *m33, *m34, *m35, *m36, *m41, *m42,*m43;

	// -----------------------------
	m1 = new_menueP("01 Zeit - Datum");
	m2 = new_menueP("02 Wecker");
	m3 = new_menueP("03 Farbe");
	m4 = new_menueP("04 Musik");

	m1 -> next = m3 -> prev = m2;
	m2 -> next = m4 -> prev = m3;
	m3 -> next = m1 -> prev = m4;
	m4 -> next = m2 -> prev = m1;

	start = m1;
	// -----------------------------

	// -----------------------------
	m11 = new_menueP("11 Zeit");
	m12 = new_menueP("12 Datum");

	m11 -> prev = m11 -> next = m12;
	m12 -> prev = m12 -> next = m11;

	m11 -> func = m_time;
	m12 -> func = m_date;

	m11 -> parent = m12 -> parent = m1;

	m1 -> child = m11;
	// -----------------------------
	
	// -----------------------------
	m21 = new_menueP("Weckzeit");
	m22 = new_menueP("Wecktyp");
	m23 = new_menueP("Weckmusik");

	m21 -> next = m23 -> prev = m22;
	m22 -> next = m21 -> prev = m23;
	m23 -> next = m22 -> prev = m21;

	m21 -> func = m_time;
	m21 -> fdata = 1;

	m21 -> parent = m22 -> parent = m23 -> parent = m2;

	m21 -> fdata = 1;

	m2 -> child = m21;
	// -----------------------------

	// -----------------------------
	m31 = new_menueP("Farbe setzen");
	m32 = new_menueP("auto Farbwechsel");
	m33 = new_menueP("Weckfarbe");
	m34 = new_menueP("auto WeFarbWechs");
	m35 = new_menueP("norm. Helligkeit");
	m36 = new_menueP("Weck-Helligkeit");

	m31 -> next = m33 -> prev = m32,
	m32 -> next = m34 -> prev = m33;
	m33 -> next = m35 -> prev = m34;
	m34 -> next = m36 -> prev = m35;
	m35 -> next = m31 -> prev = m36;
	m36 -> next = m32 -> prev = m31;

	m31 -> parent = m32 -> parent = m33 -> parent = m34 -> parent = m35 -> parent = m36 -> parent = m3;

	m3 -> child = m31;
	// -----------------------------
	
	// -----------------------------
	m41 = new_menueP("MP3-Player");
	m42 = new_menueP("Lautstaerke");
	m43 = new_menueP("Weck-Song");

	m41 -> next = m43 -> prev = m42;
	m42 -> next = m41 -> prev = m43;
	m43 -> next = m42 -> prev = m41;

	m41 -> parent = m42 -> parent = m43 -> parent = m4;

	m4 -> child = m41;
	// -----------------------------

	return;

}

// --------------------------------------------------------------------------

// Funktionen fr die Mennavigation
void menue(){

	struct menueP *tmp;
	void (*function)(uint8_t);

	tmp = start;

	while( tmp ){

		// Innerhalb des Mens
		function = tmp -> func;
		keybrd = 0x00;

		
		// Anzeigen des Menpunktes
		lcd_bg(1);						// Displaybeleuchtung an
		lcd_clear();					// Display lschen
		lcd_home();

		lcd_string(tmp -> name);


		while( !keybrd ){

			set_cursor(7,2);
			lcd_string(">");

			// ggf.Funktion aufrufen
			if( keybrd == 0x08 && *function  ){
				
				lcd_clear();

				(*function)(tmp -> fdata);

				keybrd = 0x20;				

			}

			// Warten auf Benutzereingabe
			if( keybrd == 0x10 ) tmp = tmp -> parent;
			if( keybrd == 0x08 && !function ) tmp = tmp -> child;
			if( keybrd == 0x04 ) tmp = tmp -> prev;
			if( keybrd == 0x02 ) tmp = tmp -> next;

		}

	}

	return;

}
