// FUNKTIONEN ZU MENPUNKTEN

void m_set_time_constant(uint8_t *constant,uint8_t i,uint8_t x,uint8_t time){
	
	//Einstellen einer Zeitkonstante

	keybrd = 0x00;

	while( keybrd != 0x10 && keybrd != 0x08 ){

		if( keybrd == 0x04 && *constant < i ){
			*constant = *constant + 1;
			keybrd = 0x00;
		}

		if( keybrd== 0x02 && *constant > 0 ){
			*constant = *constant - 1;
			keybrd = 0x00;
		}

		set_cursor(x, 1);

		// Zeit oder Datum anzeigen?
		if( time ) show_time();
		else {

			show_wkday();
			show_date();

		}

		if( keybrd == 0x10 ) return;

		_delay_ms(100);

	}

	keybrd = 0x00;

	return;

}


// ----------------------------------------------------------------------------------------


void m_date(uint8_t x){

	// Einstellen des Datums
	get_time();
	new_timestamp = timestamp;

	edit_time = 1;

	// Wochentag
	m_set_time_constant(&new_timestamp.wkday, 6, 3, 0);

	// tDay
	m_set_time_constant(&new_timestamp.tday, 3, 3, 0);

	// nDay
	while( keybrd != 0x10 && keybrd != 0x08 ){

		if( keybrd == 0x04 && new_timestamp.nday < 9 && new_timestamp.tday < 3 ) new_timestamp.nday++;
		else if( keybrd == 0x04 && !new_timestamp.nday && new_timestamp.tday > 2 ) new_timestamp.nday++;
		if( keybrd == 0x02 && new_timestamp.nday > 0 ) new_timestamp.nday--;

		keybrd = 0x00;

		set_cursor(3, 1);
		show_wkday();
		show_date();

		if( keybrd == 0x10 ) return;

		_delay_ms(100);

	}

	// tMon
	m_set_time_constant(&new_timestamp.tmon, 1, 3, 0);

	// nMon
	m_set_time_constant(&new_timestamp.nmon, 9, 3, 0);

	set_date_time();

	return;

}


// ----------------------------------------------------------------------------------------


void m_time(uint8_t alarm){

	// Einstellen einer Uhrzeit
	get_time();
	new_timestamp = timestamp;
	new_timestamp.tsec = new_timestamp.nsec = 0;

	edit_time = 1;

	//tHours
	m_set_time_constant(&new_timestamp.thours, 2, 4, 1);

	keybrd = 0x00;

	//nHours
	while( keybrd != 0x10 && keybrd != 0x08 ){

		if( keybrd == 0x04 && new_timestamp.nhours < 9 && new_timestamp.thours < 2 ) new_timestamp.nhours++;
		else if( keybrd == 0x04 && new_timestamp.nhours < 4 && new_timestamp.thours > 1 ) new_timestamp.nhours++;
		if( keybrd == 0x02 && new_timestamp.nhours > 0 ) new_timestamp.nhours--;

		keybrd = 0x00;

		set_cursor(4, 1);
		show_time();

		if( keybrd == 0x10 ) return;

		_delay_ms(100);

	}

	//tMin
	m_set_time_constant(&new_timestamp.tmin, 5, 4, 1);

	//nMin
	m_set_time_constant(&new_timestamp.nmin, 9, 4, 1);

	if( !alarm ) set_date_time();

	return;

}
